# objedná zpětné voláníá na Asterisku přes Asterisk manager API
# http://www.voip-info.org/wiki/view/Asterisk+manager+API
# Vhodné pokud máte vlastní pobočkovou ústřednu Asterisk.

require 'socket'      # Sockets are in standard library


hostname = '10.10.10.10' # ip adresa Asterisku
port = 5038

# Otevřený TCP port je možné testovat i pomocí telnetu
# telnet localhost 5038
# telnet 10.10.10.10 5038

s = TCPSocket.open(hostname, port)

s.write("Action: login\r\nUsername: user\r\nSecret: myusers\r\nEvents: off\r\n\r\n")

line=s.readline until line == "\r\n"


# dokumentace k tomu co je možné poslat
# http://www.voip-info.org/wiki/view/Asterisk+Manager+API+Action+Originate
#



# vyplnte defaultni cislo z ktereho budeme spojovat
# Tohle cislo bude pouzito jen pokud bylo jako parametr predano jen jedine cislo
VOLANO_Z_DEFAULT="SIP/315"

# soubor do ktereho budou logovany pokusy a pripadne chyby
# Pokud logovani chcete vypnout, nastavte LOG_FILE na prazdny retezec
LOG_FILE = File.expand_path(File.dirname(__FILE__)) +'\odorik_callback.log'


co_predali=ARGV[0]
if co_predali==nil or co_predali==""
 puts "program je treba spustit s parametry  'odorik:cislo_odkud;cislo_kam'"
 exit
end  
protokol,argument=co_predali.split(':')
cisla,akce=argument.split('?')
 
volano_z,volano_na=cisla.split(';')
if volano_na=="" or volano_na==nil
# je zde hlavne kvuli moznosti vyuziti z chrome, ktery posila jen
# jeden parametr a nemusi z cisla smazat oddelovaci znaky	
    volano_na=volano_z.gsub(/[ \-\/\(\)]/,'').gsub(/^\+/,'00')
    volano_z=VOLANO_Z_DEFAULT
end    
 
 
if %w[ odorik tel callto ].include?(protokol.downcase) and (akce=="" or akce==nil or akce=="call")
s.write("Action: Originate\r
Channel: #{volano_z}\r
Context: outgoing\r
Exten: #{volano_na}\r
Priority: 1\r
Callerid: 999\r
Timeout: 10000\r
Account:315\r\n\r\n")

s.close   
end
